#include <time.h>
#include "Log.h"

/*
 * hinstDLL = NULL Ȃ, ɂ.
 */
Log::Log() : m_logfp(NULL), m_is1st(true)
{
}

void
Log::Init(HINSTANCE hinstDLL)
{
        if (NULL == hinstDLL) return;

        char mdlname[_MAX_PATH+2];
        GetModuleFileName((HINSTANCE)hinstDLL, mdlname, _MAX_PATH);
        LPSTR pext = strrchr(mdlname, '.');
        if (pext) *pext = '\0';
        snprintf(m_logfname, sizeof(m_logfname), "%s.log", mdlname);
}

Log::~Log()
{
        if (m_logfp) {
                fclose(m_logfp);
                m_logfp = NULL;
        }
}

void
Log::Printf(char *fmt, ...)
{
        int err;
        err = Fopen();
        if (err) {
                return;
        }

        time_t cur_time;
        struct tm lctime;
        char tmbuf[48];
        char buf[512];
        va_list args;
#ifdef _MSC_VER
        // Ԃ𕶎Ɏ擾BtmbufɓB
        time(&cur_time);
        err = localtime_s(&lctime, &cur_time);
        if (err) {
                return;
        }
        strftime(tmbuf, sizeof(tmbuf), "%m/%d(%a).%H:%M:%S", &lctime);

        va_start(args, fmt);    /* ό̏ */
        vsnprintf_s(buf, sizeof(buf), _TRUNCATE, fmt, args); /* ό̏to */
        va_end(args);           /* ό̃Zbg */

#else  // #ifdef _MSC_VER
        struct tm *lctimep;
        // Ԃ𕶎Ɏ擾BtmbufɓB
        time(&cur_time);
        lctimep = localtime(&cur_time);
        strftime(tmbuf, sizeof(tmbuf), "%m/%d(%a).%H:%M:%S", lctimep);

        va_start(args, fmt);    /* ό̏ */
        vsnprintf(buf, sizeof(buf), fmt, args); /* ό̏to */
        va_end(args);           /* ό̃Zbg */
#endif // _MSC_VER

        fprintf(m_logfp, "%s %s", tmbuf, buf);
}

int
Log::Fopen()
{
        int err;
        if (m_logfp) {
                return 0;
        }

        if (m_is1st) {
#ifdef _MSC_VER
                err = fopen_s(&m_logfp, m_logfname, "w");
#else
                m_logfp = fopen(m_logfname, "w");
                err = (m_logfp) ? 0 : -1;
#endif // _MSC_VER
                if (err == 0) {
                        fclose(m_logfp);
                }
                m_is1st = false;
        }

#ifdef _MSC_VER
        err = fopen_s(&m_logfp, m_logfname, "a");
#else
        m_logfp = fopen(m_logfname, "a");
        err = (m_logfp) ? 0 : -1;
#endif // _MSC_VER
        if (err) {
                m_logfp = NULL;
                return -1;
        }
        return 0;
}
