#ifndef LOG_H
#define LOG_H

#include <stdio.h>
#include <windows.h>

#ifdef _MSC_VER
#define snprintf _snprintf_s
#endif

/*
 * Log
 */
class Log {
 public:
        Log();
        ~Log();
        void Init(HINSTANCE);
        void Printf(char *fmt, ...);
 private:
        FILE * m_logfp;
        bool m_is1st;
        char m_logfname[_MAX_PATH+2]; // Ot@C
        int Fopen();
};

/*
 * FuncTrace
 */
class FuncTrace {
public:
        FuncTrace(Log & i_log, const char * i_name) {
                m_log = &i_log;
                snprintf(m_name, sizeof(m_name), "%s", i_name);
                m_log->Printf("> %s\n", m_name);
        }
        ~FuncTrace() {
                m_log->Printf("< %s\n", m_name);
        }
private:
        char m_name[80];
        Log * m_log;
};
#define FUNCTRACE(obj,fnc) FuncTrace trc(obj,fnc)

#endif // LOG_H
