#ifndef MKAEAPI_H
#define MKAEAPI_H

#include <windows.h>
#include "Plugin.h"

// RegisterCustomList(), UnregisterCustomList()
typedef int (__stdcall *MkaeNewCustomListFunc_t)(
        const MkaeList_t *, const int,
        const MkaeCustomList_t *, const int);
typedef void (__stdcall *MkaeGetCustomListFunc_t)(
        MkaeList_t *, const int, 
        MkaeCustomList_t *, const int);
typedef void (__stdcall *MkaeDeleteCustomListFunc_t)(void);

// EnterMode(), ExitMode()
typedef void (__stdcall *MkaeEnterModeFunc_t)();
typedef int  (__stdcall *MkaeExecEnterModeFunc_t)(
        const WORD, int, int, int, const int);
typedef void (__stdcall *MkaeExitEnterModeFunc_t)();

/******************************************************************
 * class MkaeAPI
 ******************************************************************/
class MkaeAPI {
 public:
        MkaeAPI();
        ~MkaeAPI() {}

        // Is..
        bool IsEnable() {return (m_hinst_mkae)?true:false;}

        // Get..
        HWND (WINAPI *GetFocusHandleByItemIndex)(const int i_index);
        HWND (WINAPI *GetFocusHandleSelected)();
        HWND (WINAPI *GetHandleByItemIndex)(const int i_index);
        HWND (WINAPI *GetHandleSelected)();
        int  (WINAPI *GetItemIndexSelected)();
        int  (WINAPI *GetList)(char *o_list, int *io_size);
        int  (WINAPI *GetInitialList)(char *o_list, int *io_size);
        void (WINAPI *GetPosition)(int *o_top, int *o_left, int *o_width, int *o_height);
        void (WINAPI *GetQuickOption)(MkaeQuickOption_t *o_fea);
        void (WINAPI *GetStatus)(MkaeStatus_t *o_stat);
        void (WINAPI *GetVersion)(char *o_verstr, size_t i_len);
        void (WINAPI *GetWindowHandles)(HWND *o_hform, HWND *o_hlistview);

        // Set..
        void (WINAPI *SetCursorByItemIndex)(const int i_index);
        void (WINAPI *SetCursorByHandle)(const HWND i_hwnd);

        // Register/Unregister..
        int  (WINAPI *RegisterFocus)(const HWND i_hwnd);
        int  (WINAPI *UnregisterFocus)(const HWND i_hwnd);
        int  (WINAPI *RegisterCustomList)(
                MkaeNewCustomListFunc_t i_newfnc, 
                MkaeGetCustomListFunc_t i_getfnc, 
                MkaeDeleteCustomListFunc_t i_deletefnc,
                unsigned int *o_uid);
        int  (WINAPI *UnregisterCustomList)(const unsigned int i_uid);

        // Enter/Exit
        void (WINAPI *EnterMode)(
                const char *i_msg,
                MkaeEnterModeFunc_t i_enterfnc, 
                MkaeExecEnterModeFunc_t i_execfnc, 
                MkaeExitEnterModeFunc_t i_exitfnc);
        void (WINAPI *ExitMode)();

        // Other
        void (WINAPI *SuspendHook)();
        void (WINAPI *UpdateList)();
        void (WINAPI *SendHotKey)(const char *i_hotkey);

        void (WINAPI *ReloadMenu)(const char *i_plgname);
        void PrintErr(const char *i_uname, const char *i_fmt, ...);

 protected:
        HINSTANCE m_hinst_mkae;

 private:
        void (WINAPI *PrintErrRaw)(const char *i_str);
};

#endif // MKAEAPI_H
